diff --git a/gdb/gdbserver/linux-low.c b/gdb/gdbserver/linux-low.c
index d5f7097..22cf51a 100644
--- a/gdb/gdbserver/linux-low.c
+++ b/gdb/gdbserver/linux-low.c
@@ -2526,7 +2526,18 @@ resume_stopped_resumed_lwps (struct inferior_list_entry *entry)
       && !lp->status_pending_p
       && thread->last_status.kind == TARGET_WAITKIND_IGNORE)
     {
-      int step = thread->last_resume_kind == resume_step;
+      int step = 0;
+
+      if (thread->last_resume_kind == resume_step)
+	{
+	  if (can_hardware_single_step ())
+	    step = 1;
+	  else
+	    {
+	      /* GDBserver must insert reinsert breakpoint for vCont;s.  */
+	      gdb_assert (has_reinsert_breakpoints (thread));
+	    }
+	}
 
       if (debug_threads)
 	debug_printf ("RSRL: resuming stopped-resumed LWP %s at %s: step=%d\n",
@@ -3477,6 +3488,18 @@ linux_wait_1 (ptid_t ptid,
       return ignore_event (ourstatus);
     }
 
+  /* Remove reinsert breakpoints for resume_step.  */
+  if (can_software_single_step ()
+      && current_thread->last_resume_kind == resume_step
+      && has_reinsert_breakpoints (current_thread))
+    {
+      stop_all_lwps (1, event_child);
+
+      delete_reinsert_breakpoints (current_ptid);
+
+      unstop_all_lwps (1, event_child);
+    }
+
   /* Note that all addresses are always "out of the step range" when
      there's no range to begin with.  */
   in_step_range = lwp_in_step_range (event_child);
@@ -4796,7 +4819,6 @@ linux_resume_one_thread (struct inferior_list_entry *entry, void *arg)
 {
   struct thread_info *thread = (struct thread_info *) entry;
   struct lwp_info *lwp = get_thread_lwp (thread);
-  int step;
   int leave_all_stopped = * (int *) arg;
   int leave_pending;
 
@@ -4865,10 +4887,22 @@ linux_resume_one_thread (struct inferior_list_entry *entry, void *arg)
 
   if (!leave_pending)
     {
+      int step = 0;
+
       if (debug_threads)
 	debug_printf ("resuming LWP %ld\n", lwpid_of (thread));
 
-      step = (lwp->resume->kind == resume_step);
+      if (lwp->resume->kind == resume_step)
+	{
+	  if (can_hardware_single_step ())
+	    step = 1;
+	  else
+	    {
+	      /* GDBserver must insert reinsert breakpoint for vCont;s.  */
+	      gdb_assert (has_reinsert_breakpoints (thread));
+	    }
+	}
+
       linux_resume_one_lwp (lwp, step, lwp->resume->sig, NULL);
     }
   else
@@ -4909,6 +4943,7 @@ linux_resume (struct thread_resume *resume_info, size_t n)
   struct thread_info *need_step_over = NULL;
   int any_pending;
   int leave_all_stopped;
+  int resume_step_is_handled = 0;
 
   if (debug_threads)
     {
@@ -4952,12 +4987,57 @@ linux_resume (struct thread_resume *resume_info, size_t n)
 	debug_printf ("Resuming, no pending status or step over needed\n");
     }
 
+  /* Before we resume the threads, if resume_step is requested by GDB,
+     stop all threads and install reinsert breakpoints.  */
+  if (!leave_all_stopped && can_software_single_step ())
+    {
+      struct inferior_list_entry *inf, *tmp;
+
+      if (debug_threads)
+	debug_printf ("Handle resume_step.\n");
+
+      ALL_INFERIORS (&all_threads, inf, tmp)
+	{
+	  struct thread_info *thread = (struct thread_info *) inf;
+	  struct lwp_info *lwp = get_thread_lwp (thread);
+
+	  if (lwp->resume != NULL && lwp->resume->kind == resume_step)
+	    {
+	      struct thread_info *saved_thread;
+
+	      if (!resume_step_is_handled)
+		{
+		  stop_all_lwps (0, NULL);
+
+		  if (debug_threads)
+		    debug_printf ("Done stopping all threads.\n");
+
+		  resume_step_is_handled = 1;
+		}
+
+	      saved_thread = current_thread;
+	      current_thread = thread;
+	      install_software_single_step_breakpoints (lwp);
+	      current_thread = saved_thread;
+
+	      if (debug_threads)
+		debug_printf ("Insert breakpoint for resume_step LWP %ld\n",
+			      lwpid_of (thread));
+	    }
+	}
+
+      if (debug_threads)
+	debug_printf ("Handle resume_step.  Done\n");
+    }
+
   /* Even if we're leaving threads stopped, queue all signals we'd
      otherwise deliver.  */
   find_inferior (&all_threads, linux_resume_one_thread, &leave_all_stopped);
 
   if (need_step_over)
     start_step_over (get_thread_lwp (need_step_over));
+  else if (resume_step_is_handled)
+    unstop_all_lwps (0, NULL);
 
   if (debug_threads)
     {
@@ -5054,7 +5134,14 @@ proceed_one_lwp (struct inferior_list_entry *entry, void *except)
       if (debug_threads)
 	debug_printf ("   stepping LWP %ld, client wants it stepping\n",
 		      lwpid_of (thread));
-      step = 1;
+
+      if (can_hardware_single_step ())
+	step = 1;
+      else
+	{
+	  /* GDBserver must insert reinsert breakpoint for vCont;s.  */
+	  gdb_assert (has_reinsert_breakpoints (thread));
+	}
     }
   else if (lwp->bp_reinsert != 0)
     {
@@ -5124,6 +5211,36 @@ proceed_all_lwps (void)
   if (debug_threads)
     debug_printf ("Proceeding, no step-over needed\n");
 
+  /* Re-install the reinsert breakpoints on software single step target
+     if the client wants it step.  */
+  if (can_software_single_step ())
+    {
+      struct inferior_list_entry *inf, *tmp;
+
+      ALL_INFERIORS (&all_threads, inf, tmp)
+	{
+	  struct thread_info *thread = (struct thread_info *) inf;
+
+	  if (thread->last_resume_kind == resume_step)
+	    {
+	      struct lwp_info *lwp = get_thread_lwp (thread);
+	      struct thread_info *saved_thread;
+
+	      saved_thread = current_thread;
+	      current_thread = thread;
+
+	      if (!has_reinsert_breakpoints (thread))
+		install_software_single_step_breakpoints (lwp);
+
+	      current_thread = saved_thread;
+
+	      if (debug_threads)
+		debug_printf ("Insert breakpoint for resume_step LWP %ld\n",
+			      lwpid_of (thread));
+	    }
+	}
+    }
+
   find_inferior (&all_threads, proceed_one_lwp, NULL);
 }
 